--- old/usr/src/uts/common/fs/smbsrv/smb2_session_setup.c	2020-04-15 01:43:37.505217095 +0000
+++ new/usr/src/uts/common/fs/smbsrv/smb2_session_setup.c	2020-04-15 01:43:37.510540723 +0000
@@ -11,6 +11,7 @@
 
 /*
  * Copyright 2017 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2020 RackTop Systems, Inc.
  */
 
 /*
@@ -30,6 +31,7 @@
 smb2_session_setup(smb_request_t *sr)
 {
 	smb_arg_sessionsetup_t	*sinfo;
+	smb_session_t *s = sr->session;
 	uint16_t StructureSize;
 	uint8_t  Flags;
 	uint8_t  SecurityMode;
@@ -80,6 +82,12 @@
 	if (rc)
 		return (SDRC_ERROR);
 
+	if (s->dialect >= SMB_VERS_3_11) {
+		ASSERT3U(s->smb31_preauth_hashid, !=, 0);
+		(void) smb31_preauth_sha512_calc(sr, &sr->command,
+		    s->smb31_preauth_hashval);
+	}
+
 	/*
 	 * Decoded everything.  Dtrace probe,
 	 * then no more early returns.
